

theory example_1 imports Isac.Isac_Knowledge
begin

section \<open>Equation Solving\<close>
text \<open>Setup equation, Eval Tree,\ldots\<close>

ML \<open>
  val expr = ["equality (-1 + -2 * z + 8 * z \<up> 2 = (0::real))", 
              "solveFor z", "solutions L"];                        
  val (dI', pI', mI') =
    ("Isac_Knowledge", 
      ["abcFormula", "degree_2", "polynomial", "univariate", "equation"],
      ["no_met"]);
\<close>

text \<open>Step through the Calculation\<close>

ML \<open>
  val (p,_,f,nxt,_,pt) = CalcTreeTEST [(expr, (dI',pI',mI'))];
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;         
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;
  val (p,_,f,nxt,_,pt) = me nxt p [] pt;         
  val (p,_,f,nxt,_,pt) = me nxt p [] pt; 
\<close>

ML \<open>
 f2str f;
 Test_Tool.show_pt pt;
\<close>

end
