(* Title: tests for mathml.sml
   Author: Walther Neuper 060311
   (c) isac-team 2006
*)
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"within struct ---------------------------------------------------";
"-----------------------------------------------------------------";
"--------- fun xml_of_term_NEW, xml_to_term_NEW ------------------";
"--------- create testdata for TestPIDE.java#testTermTransfer ----";
"-----------------------------------------------------------------";
"exported from struct --------------------------------------------";
"-----------------------------------------------------------------";
"--------- ... ---------------------------------------------------";
"-----------------------------------------------------------------";



"-----------------------------------------------------------------";
"within struct ---------------------------------------------------";
"-----------------------------------------------------------------";
(*==================================================================*)


"--------- fun xmlstr --------------------------------------------";
"--------- fun xmlstr --------------------------------------------";
"--------- fun xmlstr --------------------------------------------";
val term = @{term "aaa + bbb::real"};
val str = term |> xml_of_term_NEW |> xmlstr 0;
if str =
"(FORMULA)\n. (ISA)\n. . aaa + bbb\n. (/ISA)\n. (TERM)\n aaa + bbb\n(/TERM)\n(/FORMULA)\n"
then () else error "term |> xml_of_term_NEW |> xmlstr ..changed";
writeln str;

"--------- fun xml_of_term_NEW, xml_to_term_NEW ------------------";
"--------- fun xml_of_term_NEW, xml_to_term_NEW ------------------";
"--------- fun xml_of_term_NEW, xml_to_term_NEW ------------------";
(* xml_of_term_NEW o xml_to_term_NEW = id ... not valid, 
  as long as the latter (going: frontend \<longrightarrow> kernel) does only carry "ISA" string.
val t = @{term "aaa + bbb::real"};
if t = (t |> xml_of_term_NEW |> xml_to_term_NEW) then ()
else error "xml_of_term_NEW |> xml_to_term_NEW changed"
*)

"--------- create testdata for TestPIDE.java#testTermTransfer ----";
"--------- create testdata for TestPIDE.java#testTermTransfer ----";
"--------- create testdata for TestPIDE.java#testTermTransfer ----";
val t = @{term "aaa + bbb::real"};
val ttt = HOLogic.mk_eq (t, Const ("processed_by_Isabelle_Isac", type_of t))
(* check the term structure *)
val Const (\<^const_name>\<open>HOL.eq\<close>, T1) $
     (Const (\<^const_name>\<open>plus\<close>, T2) $ 
        Free ("aaa", T3) $ 
        Free ("bbb", _)) $
      Const ("processed_by_Isabelle_Isac", _) = ttt;

(* check the type structure *)
atomtyp T3;
Type (\<^type_name>\<open>real\<close>, []);

atomtyp T2;
(*
*** Type (fun,[
*** . Type (Real.real,[])
*** . Type (fun,[
*** . . Type (Real.real,[])
*** . . Type (Real.real,[])
*** . . ]
*** . ]
with this \<up> build the typ ...*)
Type (\<^type_name>\<open>fun\<close>, [
  Type (\<^type_name>\<open>real\<close>, []), 
  Type (\<^type_name>\<open>fun\<close>, [
    Type (\<^type_name>\<open>real\<close>, []), 
    Type (\<^type_name>\<open>real\<close>, [])])]);

atomtyp T1;
(*
*** Type (fun,[
*** . Type (Real.real,[])
*** . Type (fun,[
*** . . Type (Real.real,[])
*** . . Type (HOL.bool,[])
*** . . ]
*** . ]
with this \<up> build the typ ...*)
Type (\<^type_name>\<open>fun\<close>, [
  Type (\<^type_name>\<open>real\<close>, []), 
  Type (\<^type_name>\<open>fun\<close>, [
    Type (\<^type_name>\<open>real\<close>, []), 
    Type (\<^type_name>\<open>bool\<close>, [])])]);

(* now compose term + typ *)
val Const (\<^const_name>\<open>HOL.eq\<close>, Type (\<^type_name>\<open>fun\<close>, [
                       Type (\<^type_name>\<open>real\<close>, []), 
                       Type (\<^type_name>\<open>fun\<close>, [
                         Type (\<^type_name>\<open>real\<close>, []), 
                         Type (\<^type_name>\<open>bool\<close>, [])])])) $
     (Const (\<^const_name>\<open>plus\<close>, Type (\<^type_name>\<open>fun\<close>, [
                                         Type (\<^type_name>\<open>real\<close>, []), 
                                         Type (\<^type_name>\<open>fun\<close>, [
                                           Type (\<^type_name>\<open>real\<close>, []), 
                                           Type (\<^type_name>\<open>real\<close>, [])])])) $ 
        Free ("aaa", Type (\<^type_name>\<open>real\<close>, [])) $ 
        Free ("bbb", Type (\<^type_name>\<open>real\<close>, []))) $
      Const ("processed_by_Isabelle_Isac", Type (\<^type_name>\<open>real\<close>, [])) = ttt;

(* match out the original term from result*)
val Const (\<^const_name>\<open>HOL.eq\<close>, Type (\<^type_name>\<open>fun\<close>, [
                       Type (\<^type_name>\<open>real\<close>, []), 
                       Type (\<^type_name>\<open>fun\<close>, [
                         Type (\<^type_name>\<open>real\<close>, []), 
                         Type (\<^type_name>\<open>bool\<close>, [])])])) $
      t' $
      Const ("processed_by_Isabelle_Isac", Type (\<^type_name>\<open>real\<close>, [])) = ttt;
if t = t' then () else error "something with test_term changed"
